models/Numeros.php
<?php
namespace app\models;

use yii\base\Model;

class Numeros extends Model{
    public $numero1;
    public $numero2;
    public $tipo;
    public $sumar;
    public $restar;
    public $multiplicar;
    public $dividir;
    //El attribute labels si tu creas un formulario de este modelo
    //te crea las etiquetas de labels
    public function attributeLabels() {
        return[
          "numero1" => "El número 1",
          "numero2"=>"El número 2",
          "sumar"=>"La suma es",
          "restar"=>"La resta es",
          "multiplicar"=>"La multiplicación es",
          "dividir"=>"La división es",
            
            
        ];
    
    }  
    public function rules(){
        return[
            [['numero1','numero2'],'integer'],
            [['numero1','numero2'],'required'],
//            ['numero2', 'compare', 'compareValue' => 0, 'operator' => '!=', 'type' => 'number','when'=>function($model){
//            $model->tipo=="dividir"; //Solo realiza la validacion si la operacion es dividir
//            }]
            ['numero2','dividirXCero']

        ];
    }  
    //Esta regla me comprueba que no estemos dividiendo por cero
    public function dividirXCero($atributo,$parametros) {
    if($this->tipo=="dividir"){
        if($this->numero2==0){
            $this->addError("numero2","PERO COMO VAS A PONER UN 0, QUE ESTAS DIVIENDO BURRO");
            }
        }
    }
        
      public function operacion() {
          
          switch($this->tipo){
              case 'sumar':
                  return $this->numero1+$this->numero2;
                  break;
              case 'restar':
                  return $this->numero1-$this->numero2;
                  break;
              case 'multiplicar':
                  return $this->numero1*$this->numero2;
                  break;
              case 'dividir':
                  return $this->numero1/$this->numero2;
                  break;
              return 0;
          }
      } 
          

          public function operarTodo() {
//              $this->tipo="sumar";
//              $this->sumar= $this->operacion();
//              
//              $this->tipo="restar";
//              $this->sumar= $this->operacion();
            $this->sumar=$this->numero1+$this->numero2;
              $this->restar=$this->numero1-$this->numero2;
              $this->multiplicar=$this->numero1*$this->numero2;
              $this->dividir=$this->numero1/$this->numero2;
              
              
          }
      }  
   
    

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\Numeros;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
  

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }
    
    public function actionSumar()
    {
        $model= new Numeros();//creando un modelo vacio que crea una clase que me crea los campos
        $model->tipo="sumar";
        $datos= Yii::$app->request->post();//recoger lo que me manda el formulario
        
        if($model->load($datos) && $model->validate()){//Compruebo si me llega algo del formulario y si siguen las rules
            //realizo la suma
            $resultado=$model->operacion("sumar");
            //La mando a la vista
            return $this->render("resultado",[
                "resultado" => $resultado,
                    "operacion"=>"Suma"
            ]) ;
        }
        return $this->render('numeros', [
        'model' => $model,
            'operacion' => 'Sumar'
        
    ]);
    }

    public function actionRestar()
    {
        $model= new Numeros();   //creando un modelo vacio que crea una clase que me crea los campos
        $model->tipo="restar";
        $datos= Yii::$app->request->post();//recoger lo que me manda el formulario
        
        if($model->load($datos) && $model->validate()){//Compruebo si me llega algo del formulario y si siguen las rules
            //realizo la resta
            $resultado=$model->operacion("restar");;
            //La mando a la vista
            return $this->render("resultado",[
                "resultado" => $resultado,
                "operacion"=>"Restar"
            ]) ;
        }
        return $this->render('numeros', [
        'model' => $model,
            'operacion' => 'restar'
        
    ]);
    }
   
    public function actionMultiplicar()
    {
        $model= new Numeros();   //creando un modelo vacio que crea una clase que me crea los campos
        $model->tipo="multiplicar";
        $datos= Yii::$app->request->post();//recoger lo que me manda el formulario
        
        if($model->load($datos) && $model->validate()){//Compruebo si me llega algo del formulario y si siguen las rules
            //realizo la resta
            $resultado=$model->operacion("multiplicar");
            //La mando a la vista
            return $this->render("resultado",[
                "resultado" => $resultado,
                "operacion"=>"Multiplicar"
            ]) ;
        }
        return $this->render('numeros', [
        'model' => $model,
            'operacion' => 'multiplicar'
        
    ]);
    
    }
    
    public function actionDividir()
    {
        $model= new Numeros();   //creando un modelo vacio que crea una clase que me crea los campos
        $model->tipo="dividir" ||$this->tipo=="todo";
        $datos= Yii::$app->request->post();//recoger lo que me manda el formulario
        
        if($model->load($datos) && $model->validate()){//Compruebo si me llega algo del formulario y si siguen las rules
            //realizo la resta
            $resultado=$model->operacion("dividir");
            //La mando a la vista
            return $this->render("resultado",[
                "resultado" => $resultado,
                "operacion"=>"Dividir"
            ]) ;
        }
        return $this->render('numeros', [
        'model' => $model,
            "operacion"=>"Dividir"
        
    ]);
    
    }
    
      public function actionOperar(){
        $model= new Numeros();   //creando un modelo vacio que crea una clase que me crea los campos
        $model->tipo="todo";
        $datos= Yii::$app->request->post();//recoger lo que me manda el formulario
        
        if($model->load($datos) && $model->validate()){//Compruebo si me llega algo del formulario y si siguen las rules
            //realizo todas las operaciones
            $model->operarTodo();
            //La mando a la vista
            return $this->render("mostrarTodo",[
                "model" => $model
            ]) ;
        }
        return $this->render('numeros', [
        'model' => $model,
        "operacion"=>"Calcular"
    ]);
    }

   
}

views/layouts/main.php
<?php

/* @var $this \yii\web\View */
/* @var $content string */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap4\Breadcrumbs;
use yii\bootstrap4\Html;
use yii\bootstrap4\Nav;
use yii\bootstrap4\NavBar;

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <?php $this->registerCsrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body class="d-flex flex-column h-100">
<?php $this->beginBody() ?>

<header>
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'options' => [
            'class' => 'navbar navbar-expand-md navbar-dark bg-dark fixed-top',
        ],
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav'],
        'items' => [
            ['label' => 'Casa', 'url' => ['/site/index']],
            ['label' => 'Sumar', 'url' => ['/site/sumar']],
            ['label' => 'Restar', 'url' => ['/site/restar']],
            ['label' => 'Multiplicar', 'url' => ['/site/multiplicar']],
            ['label' => 'Dividir', 'url' => ['/site/dividir']],
            ['label' => 'Operalo todo', 'url' => ['/site/operar']],

        ],
    ]);            
    NavBar::end();
    ?>
</header>

<main role="main" class="flex-shrink-0">
    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</main>

<footer class="footer mt-auto py-3 text-muted">
    <div class="container">
        <p class="float-left">Desarrollo curso Programación Orientada a Objetos</p>
        <p class="float-right">Fernando Martínez Beceiro.</p>
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        Abortamos misión
    </p>
    <p>
        Sigan sigan.
    </p>

</div>

views/site/index.php
<?php

/* @var $this yii\web\View */

$this->title = 'OPERA OPERADOR';
?>
<div class="site-index">

    <div class="jumbotron text-center bg-transparent">
        <h1 class="display-4">OPERATOR</h1>

        <p class="lead">Vas a flipar en colores.</p>

        
    </div>

    <div class="body-content">


    </div>
</div>

views/site/mostrarTodo.php
<?php

use yii\widgets\DetailView;

echo DetailView::widget([
    "model" => $model,
    "attributes"=>[
        'numero1',
        'numero2',
        'sumar',
        'restar',
        'multiplicar',
        'dividir',
        
    ]
]);

views/site/numeros.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Sumar */
/* @var $form ActiveForm */
?>
<div class="site-sumar">

    <?php $form = ActiveForm::begin(); ?>

        <?= $form->field($model, 'numero1') ?>
        <?= $form->field($model, 'numero2') ?>
    
        <div class="form-group">
            <?= Html::submitButton($operacion, ['class' => 'btn btn-primary']) ?>
        </div>
    <?php ActiveForm::end(); ?>

</div><!-- site-sumar -->

views/site/resultado.php
<div align="center" class="col-lg-8 mx-auto bs-primary p-3 rounded">
    El resultado de la <?= $operacion ?> es... <h1><?= $resultado ?></h1>
</div>